// 004 xxx
// 05 nov 2007

// -- Copyright (C) Felix John COLIBRI 2004 - All Rigths Reserved
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit a_32_role_admin;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Security, System.Web.UI.WebControls.WebParts, System.Configuration,
  Borland.Data.DataStore, Borland.Data.AdoDbxClientProvider;

type
  TDefault = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure list_roles__Click(sender: System.Object; e: System.EventArgs);
    procedure clear_display__Click(sender: System.Object; e: System.EventArgs);
    procedure add_userinrole___Click(sender: System.Object; e: System.EventArgs);
    procedure list_userinrole__Click(sender: System.Object; e: System.EventArgs);
    procedure fill_users_roles__Click(sender: System.Object; e: System.EventArgs);
    procedure list_users__Click(sender: System.Object; e: System.EventArgs);
    procedure get_roles_for_user__Click(sender: System.Object; e: System.EventArgs);
    procedure get_users_in_role__Click(sender: System.Object; e: System.EventArgs);
    procedure is_user_in_role__Click(sender: System.Object; e: System.EventArgs);
    procedure add_role__Click(sender: System.Object; e: System.EventArgs);
    procedure find_users_in_role__Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    DataStoreConnection1: Borland.Data.DataStore.DataStoreConnection;
    general_command_: Borland.Data.DataStore.DataStoreCommand;
    insert_role_comand_: Borland.Data.DataStore.DataStoreCommand;
    list_roles_: System.Web.UI.WebControls.Button;
    clear_display_: System.Web.UI.WebControls.Button;
    drop_role_: System.Web.UI.WebControls.Button;
    drop_membership_: System.Web.UI.WebControls.Button;
    create_usersinroles_: System.Web.UI.WebControls.Button;
    add_userinrole_: System.Web.UI.WebControls.Button;
    delete_usersinroles_: System.Web.UI.WebControls.Button;
    drop_usersinroles_: System.Web.UI.WebControls.Button;
    list_usersinroles_: System.Web.UI.WebControls.Button;
    add_userinrole__: System.Web.UI.WebControls.Button;
    list_userinrole_: System.Web.UI.WebControls.Button;
    insert_usersinroles_command_: Borland.Data.DataStore.DataStoreCommand;
    userinrole_roleid_textbox_: System.Web.UI.WebControls.TextBox;
    userinrole_userid_textbox_: System.Web.UI.WebControls.TextBox;
    user_listbox_: System.Web.UI.WebControls.ListBox;
    fill_users_roles_: System.Web.UI.WebControls.Button;
    DataStoreSelectCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreInsertCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreUpdateCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreDeleteCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreDataAdapter1: Borland.Data.DataStore.DataStoreDataAdapter;
    DataSet1: System.Data.DataSet;
    DataTable1: System.Data.DataTable;
    DataTable2: System.Data.DataTable;
    list_users_: System.Web.UI.WebControls.Button;
    roles_listbox_: System.Web.UI.WebControls.ListBox;
    username_textbox_: System.Web.UI.WebControls.TextBox;
    rolename_textbox_: System.Web.UI.WebControls.TextBox;
    do_add_checkbox_: System.Web.UI.WebControls.CheckBox;
    TextBox1: System.Web.UI.WebControls.TextBox;
    get_roles_for_user_: System.Web.UI.WebControls.Button;
    get_user_roles_textbox_: System.Web.UI.WebControls.TextBox;
    get_users_in_role_: System.Web.UI.WebControls.Button;
    get_role_users_textbox_: System.Web.UI.WebControls.TextBox;
    is_user_in_role_: System.Web.UI.WebControls.Button;
    role_id_textbox_: System.Web.UI.WebControls.TextBox;
    role_name_textbox_: System.Web.UI.WebControls.TextBox;
    add_role_: System.Web.UI.WebControls.Button;
    find_users_in_role_: System.Web.UI.WebControls.Button;
  protected
    procedure OnInit(e: EventArgs); override;
  private
    { Private Declarations }
  public
    procedure display(p_text: String);
    procedure clear_display;
  end;

implementation
  uses system.data.common // dbConnection
   ;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TDefault.InitializeComponent;
type
  TArrayOfSystem_Data_DataTable = array of System.Data.DataTable;
begin
  Self.general_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreConnection1 := Borland.Data.DataStore.DataStoreConnection.Create;
  Self.insert_role_comand_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.insert_usersinroles_command_ := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreSelectCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreInsertCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreUpdateCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreDeleteCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreDataAdapter1 := Borland.Data.DataStore.DataStoreDataAdapter.Create;
  Self.DataSet1 := System.Data.DataSet.Create;
  Self.DataTable1 := System.Data.DataTable.Create;
  Self.DataTable2 := System.Data.DataTable.Create;
  (System.ComponentModel.ISupportInitialize(Self.DataStoreDataAdapter1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable2)).BeginInit;
  Include(Self.list_roles_.Click, Self.list_roles__Click);
  Include(Self.clear_display_.Click, Self.clear_display__Click);
  Include(Self.add_userinrole__.Click, Self.add_userinrole___Click);
  Include(Self.list_userinrole_.Click, Self.list_userinrole__Click);
  Include(Self.fill_users_roles_.Click, Self.fill_users_roles__Click);
  Include(Self.list_users_.Click, Self.list_users__Click);
  Include(Self.get_roles_for_user_.Click, Self.get_roles_for_user__Click);
  Include(Self.get_users_in_role_.Click, Self.get_users_in_role__Click);
  Include(Self.is_user_in_role_.Click, Self.is_user_in_role__Click);
  Include(Self.add_role_.Click, Self.add_role__Click);
  // 
  // general_command_
  // 
  Self.general_command_.CommandText := nil;
  Self.general_command_.CommandTimeout := 0;
  Self.general_command_.Connection := Self.DataStoreConnection1;
  // 
  // DataStoreConnection1
  // 
  Self.DataStoreConnection1.ConnectionString := 'host=LocalHost;database=C:\' +
  'programs\us\web\asp_net\membership_roles_profile\_data\bfs_membership_man' +
  'ual.jds;user=SYSDBA;password=masterkey;protocol=TCP';
  // 
  // insert_role_comand_
  // 
  Self.insert_role_comand_.CommandText := nil;
  Self.insert_role_comand_.CommandTimeout := 0;
  Self.insert_role_comand_.Connection := Self.DataStoreConnection1;
  Self.insert_role_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_role_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_role_comand_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // insert_usersinroles_command_
  // 
  Self.insert_usersinroles_command_.CommandText := nil;
  Self.insert_usersinroles_command_.CommandTimeout := 0;
  Self.insert_usersinroles_command_.Connection := Self.DataStoreConnection1;
  Self.insert_usersinroles_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  Self.insert_usersinroles_command_.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create(nil, 
        Borland.Data.DataStore.DataStoreType.VarChar, System.Data.ParameterDirection.Input, 
        nil, System.Data.DataRowVersion.Current));
  // 
  // DataStoreSelectCommand1
  // 
  Self.DataStoreSelectCommand1.CommandText := nil;
  Self.DataStoreSelectCommand1.CommandTimeout := 0;
  Self.DataStoreSelectCommand1.Connection := Self.DataStoreConnection1;
  // 
  // DataStoreInsertCommand1
  // 
  Self.DataStoreInsertCommand1.CommandText := nil;
  Self.DataStoreInsertCommand1.CommandTimeout := 0;
  Self.DataStoreInsertCommand1.Connection := nil;
  // 
  // DataStoreUpdateCommand1
  // 
  Self.DataStoreUpdateCommand1.CommandText := nil;
  Self.DataStoreUpdateCommand1.CommandTimeout := 0;
  Self.DataStoreUpdateCommand1.Connection := nil;
  // 
  // DataStoreDeleteCommand1
  // 
  Self.DataStoreDeleteCommand1.CommandText := nil;
  Self.DataStoreDeleteCommand1.CommandTimeout := 0;
  Self.DataStoreDeleteCommand1.Connection := nil;
  // 
  // DataStoreDataAdapter1
  // 
  Self.DataStoreDataAdapter1.DataSet := nil;
  Self.DataStoreDataAdapter1.DeleteCommand := Self.DataStoreDeleteCommand1;
  Self.DataStoreDataAdapter1.InsertCommand := Self.DataStoreInsertCommand1;
  Self.DataStoreDataAdapter1.SelectCommand := Self.DataStoreSelectCommand1;
  Self.DataStoreDataAdapter1.UpdateCommand := Self.DataStoreUpdateCommand1;
  // 
  // DataSet1
  // 
  Self.DataSet1.DataSetName := 'NewDataSet';
  Self.DataSet1.Tables.AddRange(TArrayOfSystem_Data_DataTable.Create(Self.DataTable1, 
          Self.DataTable2));
  // 
  // DataTable1
  // 
  Self.DataTable1.TableName := 'Table1';
  // 
  // DataTable2
  // 
  Self.DataTable2.TableName := 'Table2';
  Include(Self.find_users_in_role_.Click, Self.find_users_in_role__Click);
  Include(Self.Load, Self.Page_Load);
  (System.ComponentModel.ISupportInitialize(Self.DataStoreDataAdapter1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable2)).EndInit;
end;
{$ENDREGION}

    procedure TDefault.display(p_text: String);
      begin
        TextBox1.Text:= TextBox1.Text+ p_text+ chr(13)+ chr(10);
      end; // display

    procedure TDefault.clear_display;
      begin
        TextBox1.Text:= '';
      end; // clear_display

    procedure TDefault.OnInit(e: EventArgs);
      begin
        //
        // Required for Designer support
        //
        InitializeComponent;
        inherited OnInit(e);
      end; // OnInit

    procedure TDefault.Page_Load(sender: System.Object; e: System.EventArgs);
      begin
        // TODO: Put role code to initialize the page here
        if not IsPostBack
          then
              fill_users_roles__Click(Nil, Nil);

      end; // Page_Load

    procedure TDefault.clear_display__Click(sender: System.Object; e: System.EventArgs);
      begin
        clear_display;
      end; // clear_display__Click

    // -- general helpers

    procedure execute_datastore_command(p_c_datastore_command: DataStoreCommand;
        p_request: String);
        // -- assumes the connection is open
      begin
        with p_c_datastore_command do
        begin
          CommandText:= p_request;
          ExecuteNonQuery;
        end; // with p_c_datastore_command
      end; // execute_datastore_command

    function f_list_datastore(p_c_datastore_command: DataStoreCommand;
        p_select_request: String): String;
        // -- assumes the connection is open
      var l_c_db_datareader: dbDataReader;
          l_column_index: Integer;
          l_row_display: String;
      begin
        with p_c_datastore_command do
        begin
          CommandText:= p_select_request;
          l_c_db_datareader:= ExecuteReader;

          Result:= '';

          while l_c_db_datareader.Read do
          begin
            l_row_display:= '';
            for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
              l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
            if Result<> ''
              then Result:= Result+ chr(13)+ chr(10);
            Result:= Result+ l_row_display;
          end; // while l_c_db_datareader.Read
        end; // with p_c_datastore_command
      end; // f_list_datastore

    // -- add a role

    const k_add_role_request=
              'INSERT INTO aspnet_roles'
            + '  (applicationid, roleid, rolename, loweredrolename)'
            + '  VALUES (1001, ?, ?, ? )'
            ;
    procedure TDefault.add_role__Click(sender: System.Object; e: System.EventArgs);
      var l_request: String;
      begin
        display('> add_role');
        display(k_add_role_request);

        DataStoreConnection1.Open;
        l_request:= k_add_role_request;
        display(l_request);

        insert_role_comand_.CommandText:= l_request;
        insert_role_comand_.Prepare;

        insert_role_comand_.Parameters[0].Value:= role_id_textbox_.Text;
        insert_role_comand_.Parameters[1].Value:= role_name_textbox_.Text;
        insert_role_comand_.Parameters[2].Value:= role_name_textbox_.Text;

        insert_role_comand_.ExecuteNonQuery;

        DataStoreConnection1.Close;

        display('< add_role');
      end; // add_role__Click

    // -- fill listboxes

    procedure TDefault.fill_users_roles__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> fill_users_roles');
        DataStoreConnection1.Open;

        general_command_.CommandText:= 'SELECT userid, username FROM aspnet_users';
        DataStoreDataAdapter1.SelectCommand:= general_command_;
        DataStoreDataAdapter1.Fill(DataSet1.Tables[0]);
        user_listbox_.DataSource:= DataSet1.Tables[0].DefaultView;
        user_listbox_.DataTextField:= 'username';
        user_listbox_.DataValueField:= 'userid';

        general_command_.CommandText:= 'SELECT roleid, rolename FROM aspnet_roles';
        DataStoreDataAdapter1.SelectCommand:= general_command_;
        DataStoreDataAdapter1.Fill(DataSet1.Tables[1]);
        roles_listbox_.DataSource:= DataSet1.Tables[1].DefaultView;
        roles_listbox_.DataTextField:= 'rolename';
        roles_listbox_.DatavalueField:= 'roleid';

        DataBind;
        DataStoreConnection1.Close;
        display('< fill_users_roles');
      end; // fill_users_roles__Click

    procedure TDefault.list_roles__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> list_all_roles');
        DataStoreConnection1.Open;
        display(f_list_datastore(general_command_, 'SELECT * FROM aspnet_roles'));
        DataStoreConnection1.Close;
        display('< list_all_roles');
      end; // list_roles__Click

    procedure TDefault.list_users__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> list_users');
        DataStoreConnection1.Open;
        display(f_list_datastore(general_command_, 'SELECT userid FROM aspnet_users'));
        DataStoreConnection1.Close;
        display('< list_users');
      end; // list_users__Click

(* no: this is not a tListbox.Click !!!
    procedure TDefault.roles_listbox__SelectedIndexChanged(sender: System.Object;
        e: System.EventArgs);
      begin
        display('> role_listbox_sel_changed');
        display('< role_listbox_sel_changed');
      end; // roles_listbox__SelectedIndexChanged
*)
    // -- usersinroles

    const k_add_userinrole_request=
              'INSERT INTO aspnet_usersinroles'
            + '   (userid, roleid'
            + '   ) '
            + '  VALUES (?, ?)'
            ;

    procedure TDefault.add_userinrole___Click(sender: System.Object; e: System.EventArgs);
      var l_user_id: String;
          l_role_id: String;

      procedure display_selected_values;
        begin
          display('> display_selected');
          with user_listbox_.SelectedItem do
          begin
            l_user_id:= Value;

            username_textbox_.Text:= Text;
            userinrole_userid_textbox_.Text:= Value;
          end;

          with roles_listbox_.SelectedItem do
          begin
            l_role_id:= Value;

            rolename_textbox_.Text:= Text;
            userinrole_roleid_textbox_.Text:= Value;
          end;

          display('< display_selected');
        end; // display_selected_values

      var l_request: String;

      begin // add_userinrole___Click
        display('> add_userinrole');
        // display(k_add_userinrole_request);

        display_selected_values;

        if do_add_checkbox_.Checked
          then begin
              DataStoreConnection1.Open;
              l_request:= k_add_userinrole_request;
              display(l_request);

              insert_usersinroles_command_.CommandText:= l_request;
              insert_usersinroles_command_.Prepare;

              insert_usersinroles_command_.Parameters[0].Value:= userinrole_userid_textbox_.Text;
              insert_usersinroles_command_.Parameters[1].Value:= userinrole_roleid_textbox_.Text;

              insert_usersinroles_command_.ExecuteNonQuery;

              DataStoreConnection1.Close;
            end;

        display('< add_userinrole');
      end; // add_userinrole___Click

    procedure TDefault.list_userinrole__Click(sender: System.Object; e: System.EventArgs);
      begin
        display('> list_all_usersinroles');

        DataStoreConnection1.Open;

        display(f_list_datastore(general_command_, 'SELECT * FROM aspnet_usersinroles'));

        DataStoreConnection1.Close;

        display('< list_all_usersinroles');
      end; // list_usersinroles__Click

    // -- prepare provider code

    const k_user_roles_request=
              'SELECT r.rolename'
            + '  FROM aspnet_roles r, aspnet_users u, aspnet_usersinroles ur'
            + '  WHERE'
            + '    (u.username= ?)'
            + '    AND (u.userid= ur.userid)'
            + '    AND (r.roleid= ur.roleid)';

    procedure TDefault.get_roles_for_user__Click(sender: System.Object; e: System.EventArgs);
      var l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_c_datastore_parameter: DataStoreParameter;

          l_column_index: Integer;
          l_row_display: String;

          p_user_name: String;
          l_result: String;
      begin
(*
        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= m_connection_string;
*)
        l_c_db_connection:= DataStoreConnection1;
        p_user_name:= get_user_roles_textbox_.Text;

        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_user_roles_request;

        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= p_user_name;
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_db_command.Prepare;

        // l_c_db_parameter:= general_command_.Parameters.Add('@Username', DbType.String, 255);
        // general_command_.Parameters.Add(l_c_db_parameter);

        l_c_db_datareader:= l_c_db_command.ExecuteReader; // (CommandBehavior.SingleRow);

        with l_c_db_datareader do
        begin
          l_result:= '';

          while l_c_db_datareader.Read do
          begin
            l_row_display:= '';
            for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
              l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
            if l_result<> ''
              then l_result:= l_result+ chr(13)+ chr(10);
            l_result:= l_result+ l_row_display;
          end; // while l_c_db_datareader.Read
        end; // with l_c_db_datareader

        display(l_result);

        l_c_db_connection.Close;
      end; // get_roles_for_user__Click

    const k_role_users_request=
              'SELECT u.username'
            + '  FROM aspnet_roles r, aspnet_users u, aspnet_usersinroles ur'
            + '  WHERE'
            + '    (r.rolename= ?)'
            + '    AND (u.userid= ur.userid)'
            + '    AND (r.roleid= ur.roleid)';

    procedure TDefault.get_users_in_role__Click(sender: System.Object; e: System.EventArgs);
      var l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_c_datastore_parameter: DataStoreParameter;

          l_column_index: Integer;
          l_row_display: String;

          p_role_name: String;
          l_result: String;
      begin
(*
        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= m_connection_string;
*)
        l_c_db_connection:= DataStoreConnection1;
        p_role_name:= get_role_users_textbox_.Text;

        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_role_users_request;

        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= p_role_name;
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_db_command.Prepare;

        // l_c_db_parameter:= general_command_.Parameters.Add('@Username', DbType.String, 255);
        // general_command_.Parameters.Add(l_c_db_parameter);

        l_c_db_datareader:= l_c_db_command.ExecuteReader; // (CommandBehavior.SingleRow);

        with l_c_db_datareader do
        begin
          l_result:= '';

          while l_c_db_datareader.Read do
          begin
            l_row_display:= '';
            for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
              l_row_display:= l_row_display+ l_c_db_datareader.GetString(l_column_index)+ ' ';
            if l_result<> ''
              then l_result:= l_result+ chr(13)+ chr(10);
            l_result:= l_result+ l_row_display;
          end; // while l_c_db_datareader.Read
        end; // with l_c_db_datareader

        display(l_result);

        l_c_db_connection.Close;
      end; // get_users_in_role__Click

    const k_is_user_in_role_request=
              'SELECT u.username'
            + '  FROM aspnet_roles r, aspnet_users u, aspnet_usersinroles ur'
            + '  WHERE'
            + '    (u.username= ?)'
            + '    AND (r.rolename= ?)'
            + '    AND (u.userid= ur.userid)'
            + '    AND (r.roleid= ur.roleid)';

    procedure TDefault.is_user_in_role__Click(sender: System.Object; e: System.EventArgs);
      var l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_c_datastore_parameter: DataStoreParameter;

          p_user_name: String;
          p_role_name: String;
          l_result: Boolean;
      begin
(*
        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= m_connection_string;
*)
        l_c_db_connection:= DataStoreConnection1;
        p_user_name:= get_user_roles_textbox_.Text;
        p_role_name:= get_role_users_textbox_.Text;

        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_is_user_in_role_request;

        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= p_user_name;
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_datastore_parameter:= DataStoreParameter.Create('role_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= p_role_name;
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_db_command.Prepare;

        l_c_db_datareader:= l_c_db_command.ExecuteReader; // (CommandBehavior.SingleRow);

        l_result:= l_c_db_datareader.Read;

        if l_result
          then display('Ok')
          else display('Not ok');

        l_c_db_connection.Close;
      end; // is_user_in_role__Click

    type TArrayOfString= array of string;

    procedure TDefault.find_users_in_role__Click(sender: System.Object; e: System.EventArgs);
      const k_role_users_request=
                'SELECT u.username'
              + '  FROM aspnet_roles r, aspnet_users u, aspnet_usersinroles ur'
              + '  WHERE'
              + '    (r.rolename= ?)'
              + '    AND (u.username= ?)'
              + '    AND (u.userid= ur.userid)'
              + '    AND (r.roleid= ur.roleid)';

      var l_c_db_connection: dbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: dbDataReader;

          l_c_datastore_parameter: DataStoreParameter;

          l_user_count: Integer;
          l_string_array: TArrayOfString;
          l_index: Integer;
      begin
(*
        l_c_db_connection:= Borland.Data.DataStore.DataStoreConnection.Create;
        l_c_db_connection.ConnectionString:= m_connection_string;
*)
        l_c_db_connection:= DataStoreConnection1;

        l_c_db_connection.Open;

        l_c_db_command:= DataStoreCommand.Create;
        l_c_db_command.Connection:= l_c_db_connection;
        l_c_db_command.CommandText:= k_role_users_request;
        l_c_db_command.Prepare;

        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= get_role_users_textbox_.Text;
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_datastore_parameter:= DataStoreParameter.Create('user_param',
            Borland.Data.DataStore.DataStoreType.VarChar);
        l_c_datastore_parameter.Value:= get_user_roles_textbox_.Text;
        l_c_db_command.Parameters.Add(l_c_datastore_parameter);

        l_c_db_datareader:= l_c_db_command.ExecuteReader;

        l_user_count:= 0;
        with l_c_db_datareader do
        begin
          while l_c_db_datareader.Read do
          begin
            Inc(l_user_count);
            SetLength(l_string_array, l_user_count);
            l_string_array[l_user_count- 1]:= l_c_db_datareader.GetString(0);
          end; // while l_c_db_datareader.Read
        end; // with l_c_db_datareader

        l_c_db_connection.Close;

        for l_index:= 0 to Length(l_string_array)- 1 do
          display('res '+ l_string_array[l_index]);
      end; // find_users_in_role__Click

    end.

